<?php

function agregar_csv($filename) {
    $json = json_decode(file_get_contents($filename), true);
    if (!$json) {
        return false;
    }

    $votos = [];
    foreach ($json['partidos'] as $partido){
        $votos[$partido['name']] = $partido['perc'];
    };

    // $hora = date("H:i");
    // originales/1_original_231022_204532.json
    $hora = substr($filename, -14, 2) . "/" . substr($filename, -16, 2) . "/20" . substr($filename, -18, 2) . "T" .
          substr($filename, -11, 2) . ":" . substr($filename, -9, 2);
    
    $presstr = "\"" . $hora . "\","
             . $votos['UNION POR LA PATRIA'] . ","
             . $votos['LA LIBERTAD AVANZA'] . "\n";



    $escstr = "\"$hora\","
            . $json['pollingPercCensus'] . ","
            . $json['percNulos'] . ","
            . $json['percRecurridos'] . ","
            . $json['percBlancos'] . ","
            . $json['percComando'] . ","
            . $json['percImpugnados'] . ","
            . $json['percAfirmativos'] . ","
            . $json['percAbstencion'] . ","
            . $json['percValid']
    . "\n";

    $sobresstr = "\"$hora\","
               . $json['sobres'] . ","
               . $json['nulos'] . ","
               . $json['recurridos'] . ","
               . $json['blancos'] . ","
               . $json['comando'] . ","
               . $json['impugnados'] . ","
               . $json['afirmativos'] . ","
               . $json['abstencion'] . ","
               . $json['valid']
    . "\n";

    
    $fpres = fopen("csv/presidente.csv", "a");
    fwrite($fpres,$presstr);
    fclose($fpres);

    echo $presstr;

    $fesc = fopen("csv/escrutado.csv", "a");
    fwrite($fesc, $escstr);
    fclose($fesc);

    echo $escstr;

    $fesc = fopen("csv/escrutado-sobres.csv", "a");
    fwrite($fesc, $sobresstr);
    fclose($fesc);

    echo $sobresstr;
    
}

function find_file($filenum) {
    $files = glob("originales/${filenum}_original_*");
    if (count($files) > 0) {
        return $files[0];
    } else {
        return false;
    }
}

function generate_csv($filenum) {
    $filename = find_file($filenum);
    while ($filename) {
        echo "Agregando a CSV $filename...";
        agregar_csv($filename);
        $filenum += 1;
        $filename = find_file($filenum);
    }
    
    return $filenum;
}

mkdir('csv');
mkdir('plots');

$filenum = 1;
while (true) {
    $filename = find_file($filenum);
    if ($filename) {
        $filenum = generate_csv($filenum);
        echo "Generando plots...";
        shell_exec("gnuplot participacion.gnuplot");
        shell_exec("gnuplot presidente.gnuplot");
        shell_exec("gnuplot sobres.gnuplot");
    } else {
        echo "Esperando 1 minuto...\n";
        sleep(60);
    }
}
    
